import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ShopDealerSetting, ShopDealerSettingParam } from './model';

/**
 * 分页查询分销商设置表
 */
export async function pageShopDealerSetting(params: ShopDealerSettingParam) {
  const res = await request.get<ApiResult<PageResult<ShopDealerSetting>>>(
    '/shop/shop-dealer-setting/page',
    params
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询分销商设置表列表
 */
export async function listShopDealerSetting(params?: ShopDealerSettingParam) {
  const res = await request.get<ApiResult<ShopDealerSetting[]>>(
    '/shop/shop-dealer-setting',
    params
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加分销商设置表
 */
export async function addShopDealerSetting(data: ShopDealerSetting) {
  const res = await request.post<ApiResult<unknown>>(
    '/shop/shop-dealer-setting',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改分销商设置表
 */
export async function updateShopDealerSetting(data: ShopDealerSetting) {
  const res = await request.put<ApiResult<unknown>>(
    '/shop/shop-dealer-setting',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除分销商设置表
 */
export async function removeShopDealerSetting(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-dealer-setting/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除分销商设置表
 */
export async function removeBatchShopDealerSetting(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-dealer-setting/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询分销商设置表
 */
export async function getShopDealerSetting(id: number) {
  const res = await request.get<ApiResult<ShopDealerSetting>>(
    '/shop/shop-dealer-setting/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
